#ifndef (MF_TopLaserElevation) #declare MF_TopLaserElevation = -85 #end
#ifndef (MF_TopLaserRotation) #declare MF_TopLaserRotation = 0 #end
#ifndef (MF_BottomLaserElevation) #declare MF_BottomLaserElevation = -85 #end
#ifndef (MF_BottomLaserRotation) #declare MF_BottomLaserRotation = 0 #end

#declare MF_QuadLaserCannonGun = object {
	union {
		object {
			superellipsoid {<0.3,0.01>}
			scale <0.5,0.4,0.5>
			texture {MF_HardwareTex1}
		}
		object {torus {0.2,0.02} rotate <0,0,90> translate <-0.45,0,0.5>}
		object {torus {0.2,0.02} rotate <0,0,90> translate <0.45,0,0.5>}
		object {box {<-0.3,-0.3,-0.6>, <0.3,0.3,0>}}
		#declare MF_QLC_Muzzle = object {
			union {
				object {
					difference {
						object {
							union {
								object {torus {0.05,0.05}}
								object {cylinder {<0,-0.05,0>, <0,0.05,0>, 0.05}}
							}
						}
						object {cylinder {<0,-0.06,0.025>, <0,0.06,0.025>, 0.1} scale <1,1,0.2>}
						object {plane {<0,0,-1>, 0}}
					}
					scale <1,1,2>
				}
				object {
					difference {
						object {cylinder {<0.05,0,-0.025>, <0.05,0,0.15>, 0.04}}
						object {cylinder {<0.05,0,-0.025>, <0.05,0,0.16>, 0.02}}
					}
				}
				object {
					difference {
						object {cylinder {<-0.05,0,-0.025>, <-0.05,0,0.15>, 0.04}}
						object {cylinder {<-0.05,0,-0.025>, <-0.05,0,0.16>, 0.02}}
					}
				}
					
			}
		}
		#declare MF_QLCBarrel = object {
			union {
				object {cylinder {<0,0,0.5>, <0,0,1.7>, 0.05}}
				object {
					difference {
						object {sphere {0,1} scale <0.18,0.18,0.6> translate <0,0,0.5>}
						object {cylinder {<0,0,0.8>, <0,0,2>, 0.07}}
					}
					texture {MF_ChromeMetal}
				}
				object {MF_QLC_Muzzle rotate <0,0,90> translate <0,0,1.8>}
			}
		}
		object {MF_QLCBarrel translate <0.2,0.2,0>}
		object {MF_QLCBarrel translate <-0.2,0.2,0>}
		object {MF_QLCBarrel translate <0.2,-0.2,0>}
		object {MF_QLCBarrel translate <-0.2,-0.2,0>}
	}
	texture {MF_GunMetal1}
	translate <0,0,0.2>
}

#declare MF_QuadLaserCannonMount = object {
	union {
		object {cylinder {<-0.7,0,0>, <0.7,0,0>, 0.08}}
		object {cylinder {<-0.75,0,0>, <-0.65,0,0>, 0.175}}
		object {cylinder {<0.65,0,0>, <0.75,0,0>, 0.175}}
		object {cylinder {<-0.7,0,0>, <-0.7,-1,0>, 0.04}}
		object {cylinder {<0.7,0,0>, <0.7,-1,0>, 0.04}}
		object {cylinder {<-0.7,-0.7,0>, <-0.7,-1.1,0>, 0.08}}
		object {cylinder {<0.7,-0.7,0>, <0.7,-1.1,0>, 0.08}}
		object {box {<-0.7,-0.75,-0.06>, <0.7,-1.05,0.06>}}
		object {box {<-0.3,-0.8,-0.1>, <0.3,-1.1,0.1>}}
		object {cylinder {<0,-0.8,0>, <0,-1.1,0>, 0.15}}
		object {cylinder {<0,-0.9,0>, <0,-2,0>, 0.1}}
		
	}
	texture {MF_HardwareTex1}
}

#declare MF_TopQuadLaserCannon = object {
	union {
		object {MF_QuadLaserCannonGun rotate <MF_TopLaserElevation,0,0>}
		object {MF_QuadLaserCannonMount}
	}
}

#declare MF_BottomQuadLaserCannon = object {
	union {
		object {MF_QuadLaserCannonGun rotate <MF_BottomLaserElevation,0,0>}
		object {MF_QuadLaserCannonMount}
	}
}
#declare MF_LaserTurretWindow = object {
	union {
		object {
			difference {
				object {cone {<0,0,0>, 1.5, <0,-0.5,0>, 0.5}}
				object {cone {<0,0.001,0>, 1.45, <0,-0.45,0>, 0.45}}
			}
			texture {MF_WindowTexture}
		}
		object {torus {1.5,0.05}}
		object {torus {0.6,0.05} translate <0,-0.5,0>}
		object {cylinder {<0,-0.5,0.6>, <0,0,1.5>, 0.05} rotate <0,0,0>}
		object {cylinder {<0,-0.5,0.6>, <0,0,1.5>, 0.05} rotate <0,45,0>}
		object {cylinder {<0,-0.5,0.6>, <0,0,1.5>, 0.05} rotate <0,90,0>}
		object {cylinder {<0,-0.5,0.6>, <0,0,1.5>, 0.05} rotate <0,135,0>}
		object {cylinder {<0,-0.5,0.6>, <0,0,1.5>, 0.05} rotate <0,180,0>}
		object {cylinder {<0,-0.5,0.6>, <0,0,1.5>, 0.05} rotate <0,225,0>}
		object {cylinder {<0,-0.5,0.6>, <0,0,1.5>, 0.05} rotate <0,270,0>}
		object {cylinder {<0,-0.5,0.6>, <0,0,1.5>, 0.05} rotate <0,315,0>}
	}
	texture {MF_HullTexFlatGrey}
}
		
#declare MF_QLC_Mount_Mount = object {
	union {
		object {
			intersection {
				object {
					union {
						object {cone {<0,-0.4,0>, 0.7, <0,0,0>,1.5}}
						object {cone {<0,0,0>, 1.5, <0,1.5,0>, 0.8}}
					}
					scale <1,1,10>
				}
				object {
					box {<-2,-1,0>, <2,2,0.2>}
				}
			}
		}
		object {
			intersection {
				object {cone {<0,0,0>, 0.1, <0,1.5,0>, 0.3} scale <100,1,1>}
				object {cone {<0,-0.01,0>, 0.3, <0,1.51,0>, 0.6} scale <1,1,100>}
			}
			translate <0,0,0.2>
		}
	}
}

#declare MF_LaserTurret = object {
	union {
		object {
			difference {
				object {cone {<0,0,0>, 4, <0,0.5,0>, 3.8}}
				object {cylinder {<0,-0.1,0>, <0,0.4,0>, 3.7}}
				object {cylinder {<0,-0.1,1.5>, <0,0.6,1.5>, 1.5}}
			}
			/* THIS IS SILLY! Why can't a normal pattern override the entries in a material_map? */
			#declare TurretBumps = normal {
				bump_map {gif "turretbm.gif" bump_size 2}
			}
			texture {
				material_map {
					gif "turretim.gif"
					texture {MF_HullTexFlatGrey normal {TurretBumps}}
					texture {MF_HullTexRed normal {TurretBumps}}
					texture {MF_HullTexDarkGrey normal {TurretBumps}}
					texture {MF_HullTexRust normal {TurretBumps}}
				}
				rotate <90,0,0>
				translate <-0.5,0,-0.5>
				scale 8
			}
		}
		object {torus {0.2,0.1} translate <2.5,0.5,-2>}
		object {cylinder {<0,0,0>, <0,0.1,0>, 0.1} translate <2.5,0.5,-2>}
		object {cylinder {<0,0,0>, <0,0.12,0>, 0.02} translate <2.5,0.5,-2>}
		object {MF_LaserTurretWindow translate <0,0.45,1.5>}
		object {
			difference {
				object {MF_QLC_Mount_Mount rotate <90,0,0> translate <0,0,-1.2> scale <1,-1,1> translate <0,0.5,0>}
				object {cylinder {<0,-0.1,1.5>, <0,0.6,1.5>, 1.5}}
			}
			texture {MF_HullTexFlatGrey}
		}
	}
	texture {MF_HullTexFlatGrey}
}

#declare MF_TopLaserTurret = object {
	union {
		object {MF_LaserTurret}
		object {MF_TopQuadLaserCannon rotate <0,MF_TopLaserRotation,0> rotate <-90,0,0> scale <1,1,-1> translate <0,0.7,1.5>}
	}
}

#declare MF_BottomLaserTurret = object {
	union {
		object {MF_LaserTurret}
		object {MF_BottomQuadLaserCannon rotate <0,MF_BottomLaserRotation,0> rotate <-90,0,0> scale <1,1,-1> translate <0,0.7,1.5>}
	}
	texture {MF_HullTexFlatGrey}
	scale <1,-1,1>
}

