// ==== Standard POV-Ray Includes ====
#include "colors.inc"	// Standard Color definitions
#include "textures.inc"	// Standard Texture definitions

#declare cam_loc = <35,45,40>// Declare camera location for Lens Flare plugin
#declare lookat = <0,0,8> // Declare look_at for Lens Flare  plugin

/*

#declare cam_loc = <15,15,15>// Declare camera location for Lens Flare plugin
#declare lookat = <5,2,10> // Declare look_at for Lens Flare  plugin

*/

camera {
    direction <0,0,1.8>
	/*
	#declare Foo = 12
	orthographic
	right <Foo*(4/3),0,0>
	up <0,Foo,0>
	*/
	location cam_loc
	look_at lookat
}

light_source { // Light source near camera for scene development
  cam_loc+<0,5,10>
  colour rgb 1
}

light_source {
    <20,-25,25>
    colour rgb 0.8
}

#include "mftextures.inc"
#include "mfturret.inc"
#include "mfcockpit.inc"
#include "mfdetails.inc"
#include "mfradar.inc"
#include "mfmandible.inc"
#include "mf_misc.inc"


object {Falcon}

