#declare MF_RadarDishPartA = object {
	union {
		object {cylinder {<-0.8,0,0>, <0.8,0,0>, 0.3}}
		object {cylinder {<-0.85,0,0>, <0.85,0,0>, 0.2}}
		object {
			intersection {
				object {cone {<0,0,0>, 0.75, <0,1.9,0>, 0.45} scale <100,1,1>}
				object {cone {<0,0,0>, 0.35, <0,1,0>, 0.15} scale <100,1,1> inverse}
				object {
					union {
						object {box {<-0.75,0,-1>, <-0.65,2,1>}}
						object {box {<0.65,0,-1>, <0.75,2,1>}}
					}
				}
			}
		}
		object {cylinder {<0,-1,0>, <0,0,0>, 1.3}}
		object {
			difference {
				object {cylinder {<0,0,0>, <0,0.1,0>, 1.2}}
				object {cylinder {<0,-0.1,0>, <0,0.2,0>, 1.1}}
			}
		}
	}
	texture {MF_HullTexFlatGrey}
}

#declare MF_RadarDishPartB = object {
	union {
		object {cylinder {<-0.65,0,0>, <0.65,0,0>, 0.3}}
		object {
			intersection {
				object {cone {<0,0,0>, 0.3, <0,3,0>, 1.8} scale <100,1,1>}
				object {cone {<0,0.3,0>, 0, <0,3,0>, 1.3} scale <100,1,1> inverse}
				object {
					union {
						object {box {<-0.65,0,-2>, <-0.55,3,2>}}
						object {box {<0.55,0,-2>, <0.65,3,2>}}
					}
				}
				object {sphere {<0,7,0>, 5} inverse}
			}
		}
	}
	texture {MF_HullTexFlatGrey}
}

#declare MF_RadarDishDish = object {
	union {
		object {
			intersection {
				object {sphere {<0,7,0>, 4.95}}
				object {sphere {<0,7,0>, 4.9} inverse}
				object {cylinder {<0,0,0>, <0,7,0>, 2.7}}
			}
			texture {
				MF_HullTexFlatGrey
				normal {
					wood
					rotate <90,0,0>
					slope_map {
						[0.0 <0,0>]
						[0.95 <0,0>]
						[0.95 <1,0>]
						[1.0 <1,0>]
					}
					scale 0.3
				}
			}
		}
		object {
			intersection {
				object {sphere {<0,7,0>, 5}}
				object {sphere {<0,7,0>, 4.95} inverse}
				object {cylinder {<0,0,0>, <0,7,0>, 2.7}}
			}
			texture {MF_HullTexFlatGrey}
		}
		object {
			intersection {
				object {
					difference {
						object {sphere {<0,7,0>, 5}}
						object {sphere {<0,7,0>, 4.8}}
					}
				}
				object {
					union {
						#declare Count = 0
						#while (Count < 360)
						object {
							box {<-0.1,1,1.5>, <0.1,4,2.5>}
							rotate <0,Count,0>
						}
						#declare Count = Count + (360/12)
						#end
					}
					texture {MF_ChromeMetal}
				}
			}
		}
					
					
		object {
			intersection {
				object {
					union {
						object {cone {<0,2,0>, 1, <0,2.5,0>, 0}}
					}
				}
				object {sphere {<0,7,0>, 4.95}}
			}
			texture {
				MF_HullTexFlatGrey
				normal {
					radial
					slope_map {
						[0.0 <0,0>]
						[0.95 <0,0>]
						[0.95 <1,0>]
						[1.0 <1,0>]
					}
					frequency 20
				}
			}
		}
		object {
			difference {
				object {cylinder {<0,1.6,0>, <0,2.6,0>, 0.8}}
				object {sphere {<0,7,0>, 5}}
				object {cylinder {<0,1.5,0>, <0,1.9,0>, 0.7}}
			}
		}
	}
	texture {MF_HullTexFlatGrey}
}	
#declare MF_RadarDish = object {
	union {
		object {MF_RadarDishPartA}
		object {MF_RadarDishPartB rotate <45,0,0> translate <0,1.6,0>}
		object {MF_RadarDishDish rotate <45,0,0> translate <0,1.6,0>}
	}
}
