#declare MF_HullTexFlatGreyPigment = pigment {
	granite
	colour_map {
		[0.0 colour rgb <0.98,0.97,0.93>]
		[0.2 colour rgb <0.94,0.93,0.90>]
		[0.4 colour rgb <1,0.97,0.96>]
		[0.8 colour rgb <0.93,0.91,0.90>]
		[1.0 colour rgb <0.95,0.94,0.93>]
	}
}

#declare MF_HullTexFlatGrey = texture { // Flat grey texture with battle-scarring
	pigment {
		spotted
		pigment_map {
			[0 MF_HullTexFlatGreyPigment] 	
			[0.8 MF_HullTexFlatGreyPigment] 	
			[1 granite pigment_map {
				[0 MF_HullTexFlatGreyPigment] 	
				[0.3 MF_HullTexFlatGreyPigment] 	
				[0.6 colour rgb 0]
				[1 colour rgb 0]
			} scale 0.1]
		}
		turbulence 0.1
	}
	finish {diffuse 0.7 ambient 0}
	scale 0.5
}

#declare MF_HullTexRedPigment = pigment {
	granite
	colour_map {
		[0.0 colour rgb <0.68,0.07,0.03>]
		[0.2 colour rgb <0.64,0.03,0.00>]
		[0.4 colour rgb <0.6,0.07,0.06>]
		[0.8 colour rgb <0.73,0.01,0.0>]
		[1.0 colour rgb <0.65,0.04,0.03>]
	}
}

#declare MF_HullTexRed = texture { // Flat grey texture with battle-scarring
	pigment {
		spotted
		pigment_map {
			[0 MF_HullTexRedPigment] 	
			[0.8 MF_HullTexRedPigment] 	
			[1 granite pigment_map {
				[0 MF_HullTexRedPigment] 	
				[0.3 MF_HullTexRedPigment] 	
				[0.6 colour rgb 0]
				[1 colour rgb 0]
			}]
		}
		turbulence 0.1
	}
	finish {diffuse 0.7 ambient 0}
	scale 0.5
}

#declare MF_HullTexDarkGreyPigment = pigment {
	granite
	colour_map {
		[0.0 colour rgb <0.68,0.67,0.63>]
		[0.2 colour rgb <0.79,0.78,0.74>]
		[0.4 colour rgb <0.7,0.63,0.65>]
		[0.8 colour rgb <0.76,0.73,0.74>]
		[1.0 colour rgb <0.74,0.72,0.73>]
	}
}

#declare MF_HullTexDarkGrey = texture { // Flat grey texture with battle-scarring
	pigment {
		spotted
		pigment_map {
			[0 MF_HullTexDarkGreyPigment] 	
			[0.8 MF_HullTexDarkGreyPigment] 	
			[1 granite pigment_map {
				[0 MF_HullTexDarkGreyPigment] 	
				[0.3 MF_HullTexDarkGreyPigment] 	
				[0.6 colour rgb 0]
				[1 colour rgb 0]
			}]
		}
		turbulence 0.1
	}
	finish {diffuse 0.7 ambient 0}
	scale 0.5
}

#declare MF_HullTexRust = texture {
	pigment {
		granite
        color_map {
            [0.0 color rgb <0.89, 0.51, 0.28>]
			[0.2 colour rgb <0.99,0.98,0.95>]
            [0.4 color rgb <0.70, 0.13, 0.00>]
            [0.5 color rgb <0.69, 0.41, 0.08>]
            [0.6 color rgb <0.49, 0.31, 0.28>]
			[0.8 colour rgb <0.96,0.95,0.94>]
            [1.0 color rgb <0.89, 0.51, 0.28>]
        }
    }
	scale 0.075
}

#declare MF_GunMetal1 = texture {
	pigment {colour rgb 0.62}
	normal {dents 0.4 scale 0.05}
	finish {metallic}
}
#declare MF_HardwareTex1 = texture {
	pigment {colour rgb <0.9,0.89,0.87>}
	normal {dents 0.4 scale 0.05}
}

#declare MF_GrilleTex1 = texture {
	pigment {colour rgb 0.01}
	
	/********************** FILL IN SPECIAL NORMAL LATER *************************/
}
#declare MF_ChromeMetal = texture {
	pigment {colour rgb 0.8}
	finish {metallic reflection 0.2 specular 0.4 roughness 0.05}
	normal {dents 0.5 scale 0.05}
}

#declare MF_WindowTexture = texture {
	pigment {colour rgbf <0.9,0.9,0.9,1>}
	finish {reflection 0.1 specular 1 roughness 0.01}
}

#declare MF_HardwareTex2 = texture {
	pigment {colour rgb <0,0.5,0.2>}
	normal {dents 0.4 scale 0.05}
}

#declare MF_HardwareTex3 = texture {
	pigment {colour rgb <0.5,0.1,0>}
	normal {dents 0.4 scale 0.05}
}

#declare MF_HardwareTex4 = texture {
	pigment {colour rgb <0,0.1,0.5>}
	normal {dents 0.4 scale 0.05}
}

